#!/bin/sh
# ###########################################################################
# Script generated by Fortify Scan Wizard (c) 2011-2023 Micro Focus or one of its affiliates
# Created on 2023/04/05 10:07:28
# ###########################################################################
# Generated for the following languages:
# 	Go
# ###########################################################################
# FPR - the name of analysis results file
# DEBUG - if set to true, runs SCA in debug mode
# SOURCEANALYZER - the name of the SCA executable
# BUILDID - the SCA build ID
# ARGFILE - the name of the argument file that's passed to SCA
# BYTECODE_ARGFILE - the name of the argument file for Java bytecode translation in the SCA
# MEMORY - the memory settings for SCA
# SCANSWITCHES - parameters to pass in the SCA analysis phase
# LAUNCHERSWITCHES - the launcher settings that are used to invoke SCA
# OLDFILENUMBER - this defines the file that contains the number of files within the project, it is automatically generated
# FILENOMAXDIFF - this is the percentage of difference between the number of files which will trigger a warning by the script
# ###########################################################################

DEBUG=false
SOURCEANALYZER=/mnt/hgfs/tools/Fortify_SCA_and_Apps_22.2.2/bin/sourceanalyzer
FPR="Fortifyproduct-catalog-service.fpr"
BUILDID="product-catalog-service"
ARGFILE="Fortifyproduct-catalog-service.sh.args"
BYTECODE_ARGFILE="Fortifyproduct-catalog-service.sh.bytecode.args"
MEMORY="-Xmx2592M -Xms400M -Xss24M "

LAUNCHERSWITCHES=""
SCANSWITCHES=""
OLDFILENUMBER="Fortifyproduct-catalog-service.sh.fileno"
FILENOMAXDIFF=10
ENABLE_BYTECODE=false

PROJECTROOT0="./"
if [ ! -d "$PROJECTROOT0" ]; then
   echo  "ERROR: This script is being run on a different machine than it was"
   echo  "       generated on or the targeted project has been moved. This script is "
   echo  "       configured to locate files at"
   echo  "          $PROJECTROOT0"
   echo  "       Please modify the \$PROJECTROOT0 variable found"
   echo  "       at the top of this script to point to the corresponding directory"
   echo  "       located on this machine."
   exit
fi

if [ $DEBUG = true ]; then export LAUNCHERSWITCHES="-debug $LAUNCHERSWITCHES"; fi
echo Extracting Arguments File


grep "# ARGS" $0 | grep -v grep | cut -d" " -f3- | sed -e s#PROJECTROOT0_MARKER#"$PROJECTROOT0"#g   > $ARGFILE

grep "# BYTECODE_ARGS" $0 | grep -v grep | cut -d" " -f3- | sed -e s#PROJECTROOT0_MARKER#"$PROJECTROOT0"#g   > $BYTECODE_ARGFILE

if [ -s $BYTECODE_ARGFILE ]; then
ENABLE_BYTECODE=true
fi
# ###########################################################################
echo Cleaning previous scan artifacts
$SOURCEANALYZER $MEMORY $LAUNCHERSWITCHES -b $BUILDID -clean 
if [ $? -ne 0 ] ; then
echo sourceanalyzer failed, exiting
exit
fi
# ###########################################################################
echo Translating files
$SOURCEANALYZER $MEMORY $LAUNCHERSWITCHES -b $BUILDID @$ARGFILE
if [ $? -ne 0 ] ; then
echo sourceanalyzer failed, exiting
exit
fi
# ###########################################################################
if [ $ENABLE_BYTECODE = true ]; then
echo Translating Java bytecode files
$SOURCEANALYZER $MEMORY $LAUNCHERSWITCHES -b $BUILDID @$BYTECODE_ARGFILE
if [ $? -ne 0 ] ; then
echo sourceanalyzer failed, exiting
exit
fi
fi
# ###########################################################################
echo Testing Difference between Translations
FILENUMBER=`$SOURCEANALYZER -b $BUILDID -show-files | wc -l`

if [ ! -f $OLDFILENUMBER ]; then
	echo It appears to be the first time running this script, setting $OLDFILENUMBER to $FILENUMBER
	echo $FILENUMBER > $OLDFILENUMBER
else
	OLDFILENO=`cat $OLDFILENUMBER`
	DIFF=`expr $OLDFILENO "*" $FILENOMAXDIFF`
	DIFF=`expr $DIFF /  100`

	MAX=`expr $OLDFILENO + $DIFF`
	MIN=`expr $OLDFILENO - $DIFF`

	if [ $FILENUMBER -lt $MIN ] ; then SHOWWARNING=true; fi
	if [ $FILENUMBER -gt $MAX ] ; then SHOWWARNING=true; fi

	if [ -n "$SHOWWARNING" ] && [ "$SHOWWARNING" = true ] ; then
		echo "WARNING: The number of files has changed by over $FILENOMAXDIFF%, it is recommended"
		echo "         that this script is regenerated with the ScanWizard"
	fi

	echo $MAX $MIN $DIFF
fi;

# ###########################################################################
echo Starting scan
$SOURCEANALYZER $MEMORY $LAUNCHERSWITCHES -b $BUILDID $SCANSWITCHES -scan -f $FPR
if [ $? -ne 0 ] ; then
echo sourceanalyzer failed, exiting
exit
fi
# ###########################################################################
echo Finished
# ARGS "PROJECTROOT0_MARKER"